﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security;
using System.Security.Cryptography;
using System.Numerics;
using Paper.Token;

namespace Paper
{
	namespace Programs
	{

		class TokenCmdLineGenerator
		{

			static void Main(string[] args)
			{
				int abi;
				int codiceFiliale;
				String matricola;
				String profilo;
				DateTime dataOra;
				BigInteger E;
				BigInteger N;

				if (args.Length == 0 || "/? /h -h --help help".Contains(args[1].ToLower()))
				{
                    Console.WriteLine("P@PAER v1.0.0");
					Console.WriteLine("Utility command-line per la generazione di Token di sicurezza");
					Console.WriteLine("USO: " + System.AppDomain.CurrentDomain.FriendlyName + " <abi> <codice filiale> <matricola> <profilo> <E> <N>");
					Console.WriteLine();
					return;
				}

				try
				{
					abi = Int32.Parse(args[0]);
					codiceFiliale = Int32.Parse(args[1]);
					matricola = args[2];
					profilo = args[3];
					dataOra = DateTime.Now;
					E = BigIntegerUtils.decodeBigInteger("E", args[4]);
					N = BigIntegerUtils.decodeBigInteger("N", args[5]);
				}
				catch (Exception e)
				{
					throw new Exception("Errore durante la decodifica dei parametri", e);
				}

				Console.WriteLine("Valori del token:");
				Console.WriteLine("ABI       = " + abi);
				Console.WriteLine("FILIALE   = " + codiceFiliale);
				Console.WriteLine("MATRICOLA = " + matricola);
				Console.WriteLine("PROFILO   = " + profilo);
				Console.WriteLine("DATA/ORA  = " + dataOra);
				Console.WriteLine();

				try
				{

					TokenGenerator generator = new TokenGenerator();

					String tokenWithHash = generator.buildTokenInfoWithHash(abi, codiceFiliale, matricola, profilo, dataOra);

					Console.WriteLine("Token con hash = " + tokenWithHash);
					Console.WriteLine();

					String cryptedToken = generator.cryptTokenWithHash(tokenWithHash, E, N);

					Console.WriteLine("URL LOGIN: https://www.caricese.it/paper/tokenlogin.do?abi=" + abi + "&token=" + cryptedToken);
				}
				catch (Exception e)
				{
					throw new Exception("Errore durante la generazione del token", e);
				}
			}
		}
	}
}




















     /*
        string buildRSAXMLKey(String N, String E)
        {
            BigInteger bigN;
            BigInteger bigE;

            System.Numerics.BigInteger.TryParse(N, out bigN);
            System.Numerics.BigInteger.TryParse(E, out bigE);

            Console.WriteLine("E: " + E);
            Console.WriteLine("E: " + bigE);
            Console.WriteLine("N: " + N);
            Console.WriteLine("N: " + bigN);


            byte[] bytesN = bigN.ToByteArray();
            byte[] bytesE = bigE.ToByteArray();

            String b64N = System.Convert.ToBase64String(bytesN, 1, 64, Base64FormattingOptions.None); ;
            String b64E = System.Convert.ToBase64String(bytesE, 1, 2, Base64FormattingOptions.None); ;
            
            return "<RSAKeyValue><Modulus>" + b64N + "</Modulus><Exponent>" + b64E + "</Exponent></RSAKeyValue>";
        }

        RSACryptoServiceProvider buildRSAKey(String N, String E)
        {
            RSACryptoServiceProvider rsa = new RSACryptoServiceProvider(512);
            rsa.FromXmlString(buildRSAXMLKey(N, E)); 
            return rsa;
        }

        void provaUnipol(string[] args)
        {
      //      RSACryptoServiceProvider RSA = buildRSAKey(
    //            "7643844973674474443490091174969202451099271677136773162629595373578493830081555799930921897319715812358435971925080750622769764713232268306162177421681257",
  //              "65537"
//            );

            BigInteger N = buildBigInteger("7643844973674474443490091174969202451099271677136773162629595373578493830081555799930921897319715812358435971925080750622769764713232268306162177421681257");
            BigInteger E = buildBigInteger("65537");

//#   RSA E: 65537
//#   RSA N: 7643844973674474443490091174969202451099271677136773162629595373578493830081555799930921897319715812358435971925080750622769764713232268306162177421681257
//#   RSA D: 3083570706837446867219906777604037023393846904804034497666985710158661822782421276864732275432001477839346539523791833812952900416721454267669973365446297


            String tokenInfo = generateToken(3127, 1, "M1234", Profilo.SC, DateTime.Now);

            //hI4Hk2nemlvpqYvUIlUyaWsrj9c=
            //String tokenInfo = "0000;3127;000;SC;2014-09-23;17:59:02";

            String criptedTokenInfo = criptaTokenInfo(tokenInfo, N, E);

            printURL(3127, criptedTokenInfo);

            Console.ReadLine();
        } 



        */